<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.3"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: include/tile/Tile.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectalign">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.3 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search",'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_f656290b9017852ece87b8a3712178e6.html">tile</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle"><div class="title">Tile.hpp</div></div>
</div><!--header-->
<div class="contents">
<a href="Tile_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="preprocessor">#pragma once</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span> </div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="preprocessor">#include &lt;SFML/Graphics.hpp&gt;</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="preprocessor">#include &lt;<a class="code" href="Event_8hpp.html">core/Event.hpp</a>&gt;</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="preprocessor">#include &lt;<a class="code" href="Attributes_8hpp.html">resources/Attributes.hpp</a>&gt;</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="preprocessor">#include &lt;string&gt;</span></div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span> </div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span><span class="keyword">namespace </span><a class="code hl_namespace" href="namespacegg.html">gg</a></div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span>{</div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span> </div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno"><a class="line" href="namespacegg.html#a08ccf34451b5441314600ac46113a9f6">   11</a></span><span class="keyword">enum class</span> <a class="code hl_enumeration" href="namespacegg.html#a08ccf34451b5441314600ac46113a9f6">TileType</a> { <a class="code hl_enumvalue" href="namespacegg.html#a08ccf34451b5441314600ac46113a9f6a4ccfea7a25fae3c1d31555f0856d2b42">Terrain</a>, <a class="code hl_enumvalue" href="namespacegg.html#a08ccf34451b5441314600ac46113a9f6ad11aed2ff81f20a2e2b7e0cf06ee1a37">Road</a>, <a class="code hl_enumvalue" href="namespacegg.html#a08ccf34451b5441314600ac46113a9f6ac39b56d4489fb2507289e7ae19567b80">Building</a> };</div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span> </div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno"><a class="line" href="structgg_1_1TileVertices.html">   13</a></span><span class="keyword">struct </span><a class="code hl_struct" href="structgg_1_1TileVertices.html">TileVertices</a> {</div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno"><a class="line" href="structgg_1_1TileVertices.html#aa9d3f0cc48da0f5b741f1eb8fa43add0">   14</a></span>    sf::Vector2f <a class="code hl_variable" href="structgg_1_1TileVertices.html#aa9d3f0cc48da0f5b741f1eb8fa43add0">left</a>;</div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno"><a class="line" href="structgg_1_1TileVertices.html#ab87101f5f35289a4fa7e8bacf14cb097">   15</a></span>    sf::Vector2f <a class="code hl_variable" href="structgg_1_1TileVertices.html#ab87101f5f35289a4fa7e8bacf14cb097">top</a>;</div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno"><a class="line" href="structgg_1_1TileVertices.html#a12a105e4bbd87645f296444aea39d985">   16</a></span>    sf::Vector2f <a class="code hl_variable" href="structgg_1_1TileVertices.html#a12a105e4bbd87645f296444aea39d985">right</a>;</div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno"><a class="line" href="structgg_1_1TileVertices.html#a60fb411502ff67e65d6f270dfa4d1fd3">   17</a></span>    sf::Vector2f <a class="code hl_variable" href="structgg_1_1TileVertices.html#a60fb411502ff67e65d6f270dfa4d1fd3">bottom</a>;</div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span>};</div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span> </div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno"><a class="line" href="classgg_1_1Tile.html">   20</a></span><span class="keyword">class </span><a class="code hl_class" href="classgg_1_1Tile.html">Tile</a> : <span class="keyword">public</span> sf::Drawable, <span class="keyword">public</span> <a class="code hl_class" href="classgg_1_1IEventSubscriber.html">IEventSubscriber</a></div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span>{</div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span>  <span class="keyword">public</span>:</div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno"><a class="line" href="classgg_1_1Tile.html#ad5401c7e1b74b3c556b1960d150c15f1">   23</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1Tile.html#ad5401c7e1b74b3c556b1960d150c15f1">draw</a>(sf::RenderTarget &amp;target, sf::RenderStates states) <span class="keyword">const override</span>;</div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno"><a class="line" href="classgg_1_1Tile.html#a76d15a17d011f27adcd9defccf00f520">   24</a></span>    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1Tile.html#a76d15a17d011f27adcd9defccf00f520">Update</a>();</div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span> </div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno"><a class="line" href="classgg_1_1Tile.html#a7266360d4b7b0603596252ffb1edce51">   26</a></span>    <a class="code hl_function" href="classgg_1_1Tile.html#a7266360d4b7b0603596252ffb1edce51">Tile</a>(</div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span>        sf::Vector2f coordinates,</div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span>        sf::Texture &amp;texture,</div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span>        std::string texture_name,</div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span>        <span class="keywordtype">unsigned</span> rotation);</div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno"><a class="line" href="classgg_1_1Tile.html#a3e180f4be66ea12ad1e2a95a66fad2e7">   31</a></span>    <a class="code hl_function" href="classgg_1_1Tile.html#a3e180f4be66ea12ad1e2a95a66fad2e7">~Tile</a>() <span class="keyword">override</span> = 0;</div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span> </div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno"><a class="line" href="classgg_1_1Tile.html#a6ccfd1b779c329f0db0434c7c84fb326">   33</a></span>    <span class="keyword">virtual</span> <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1Tile.html#a6ccfd1b779c329f0db0434c7c84fb326">GetAttributes</a>() -&gt; <a class="code hl_class" href="classgg_1_1Attributes.html">Attributes</a> = 0;</div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno"><a class="line" href="classgg_1_1Tile.html#a5df93094d59293b454a041b1fc780b51">   34</a></span>    <span class="keyword">virtual</span> <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1Tile.html#a5df93094d59293b454a041b1fc780b51">GetTileType</a>() -&gt; <a class="code hl_enumeration" href="namespacegg.html#a08ccf34451b5441314600ac46113a9f6">TileType</a> = 0;</div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span> </div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span>    <span class="comment">// Returns vertices in the following order:</span></div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span>    <span class="comment">// Left, Up, Right, Down</span></div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno"><a class="line" href="classgg_1_1Tile.html#a389b4f46707f195fa2ed2e22ec221cb6">   38</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1Tile.html#a389b4f46707f195fa2ed2e22ec221cb6">GetVertices</a>() -&gt; <a class="code hl_struct" href="structgg_1_1TileVertices.html">TileVertices</a>;</div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno"><a class="line" href="classgg_1_1Tile.html#af6c613329acd85d3a7ebf194ae5fa763">   39</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1Tile.html#af6c613329acd85d3a7ebf194ae5fa763">GetCoordinates</a>() -&gt; sf::Vector2f;</div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno"><a class="line" href="classgg_1_1Tile.html#a53d8865c694dfb8240eddce9fe1d6254">   40</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1Tile.html#a53d8865c694dfb8240eddce9fe1d6254">GetTexture</a>() -&gt; sf::Texture *;</div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno"><a class="line" href="classgg_1_1Tile.html#ad6b1fa9f1db1fb5aacb6bfb5f2984ad9">   41</a></span>    <span class="keyword">inline</span> <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1Tile.html#ad6b1fa9f1db1fb5aacb6bfb5f2984ad9">GetTextureName</a>() const -&gt; const <a class="code hl_namespace" href="namespacestd.html">std</a>::<span class="keywordtype">string</span> &amp;</div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span>    {</div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span>        <span class="keywordflow">return</span> <a class="code hl_variable" href="classgg_1_1Tile.html#ab2075c2d7f3e48756092e2ffc4285119">mTextureName</a>;</div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span>    }</div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span> </div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno"><a class="line" href="classgg_1_1Tile.html#aa73c8e60689b326a699777bf379ed67f">   46</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1Tile.html#aa73c8e60689b326a699777bf379ed67f">SetTexture</a>(std::string &amp;);</div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno"><a class="line" href="classgg_1_1Tile.html#a0191b303c80a99a08d039b5bf750634c">   47</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1Tile.html#a0191b303c80a99a08d039b5bf750634c">SetCoordinates</a>(sf::Vector2f);</div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno"><a class="line" href="classgg_1_1Tile.html#a3ac25ea653262607007c15e5d68f9685">   48</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1Tile.html#a3ac25ea653262607007c15e5d68f9685">GetOrientation</a>() -&gt; unsigned;</div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span> </div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno"><a class="line" href="classgg_1_1Tile.html#a10ad4cf3efcbf28f9619728645dbf177">   50</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1Tile.html#a10ad4cf3efcbf28f9619728645dbf177">OnEvent</a>(<a class="code hl_class" href="classgg_1_1IEvent.html">IEvent</a> *e) <span class="keyword">override</span>;</div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span> </div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span>  <span class="keyword">protected</span>:</div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno"><a class="line" href="classgg_1_1Tile.html#a16878527ccba59914b345b7cf314df94">   53</a></span>    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1Tile.html#a16878527ccba59914b345b7cf314df94">OnMouseMoved</a>(<a class="code hl_class" href="classgg_1_1IEvent.html">IEvent</a> *e);</div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno"><a class="line" href="classgg_1_1Tile.html#a301a080e5cdb580c2224a9548de9d753">   54</a></span>    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1Tile.html#a301a080e5cdb580c2224a9548de9d753">OnMousePressed</a>(<a class="code hl_class" href="classgg_1_1IEvent.html">IEvent</a> *e);</div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno"><a class="line" href="classgg_1_1Tile.html#a1d29c8525bf4ff2360d8ed2da06417a2">   55</a></span>    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1Tile.html#a1d29c8525bf4ff2360d8ed2da06417a2">OnKeyboardReleased</a>(<a class="code hl_class" href="classgg_1_1IEvent.html">IEvent</a> *e);</div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span> </div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno"><a class="line" href="classgg_1_1Tile.html#a79fb964ccb4a15eafbca90b4de886c63">   57</a></span>    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1Tile.html#a79fb964ccb4a15eafbca90b4de886c63">Align</a>() = 0;</div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span> </div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span>  <span class="keyword">private</span>:</div>
<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span>    <span class="keywordtype">void</span> SetHover(<span class="keywordtype">bool</span>);</div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span>    <span class="keyword">auto</span> IsContained(<span class="keyword">const</span> sf::Vector2f &amp;) -&gt; bool;</div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span>    <span class="keywordtype">void</span> ApplyGlow();</div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span> </div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>  <span class="keyword">protected</span>:</div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno"><a class="line" href="classgg_1_1Tile.html#aa41280d666d951b77e2b350abe440b57">   65</a></span>    sf::Texture *<a class="code hl_variable" href="classgg_1_1Tile.html#aa41280d666d951b77e2b350abe440b57">mTexture</a>;</div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno"><a class="line" href="classgg_1_1Tile.html#a716d8b8c491751d505c16efdfdb09ffd">   66</a></span>    sf::Vector2f <a class="code hl_variable" href="classgg_1_1Tile.html#a716d8b8c491751d505c16efdfdb09ffd">mCoordinates</a>;</div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno"><a class="line" href="classgg_1_1Tile.html#ac25ae0051a743d6d2268055b9b2a80f7">   67</a></span>    sf::Sprite <a class="code hl_variable" href="classgg_1_1Tile.html#ac25ae0051a743d6d2268055b9b2a80f7">mSprite</a>;</div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno"><a class="line" href="classgg_1_1Tile.html#ab2075c2d7f3e48756092e2ffc4285119">   68</a></span>    std::string <a class="code hl_variable" href="classgg_1_1Tile.html#ab2075c2d7f3e48756092e2ffc4285119">mTextureName</a>;</div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno"><a class="line" href="classgg_1_1Tile.html#a1f5447e844dced086af932cd654624b8">   69</a></span>    <span class="keywordtype">unsigned</span> <a class="code hl_variable" href="classgg_1_1Tile.html#a1f5447e844dced086af932cd654624b8">mRotation</a> = 0;</div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span> </div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>  <span class="keyword">private</span>:</div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>    <span class="keywordtype">bool</span> mDirty = <span class="keyword">false</span>;</div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span>    <span class="keywordtype">bool</span> mHovered = <span class="keyword">false</span>;</div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span>};</div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span>}; <span class="comment">// namespace gg</span></div>
<div class="ttc" id="aAttributes_8hpp_html"><div class="ttname"><a href="Attributes_8hpp.html">Attributes.hpp</a></div></div>
<div class="ttc" id="aEvent_8hpp_html"><div class="ttname"><a href="Event_8hpp.html">Event.hpp</a></div></div>
<div class="ttc" id="aclassgg_1_1Attributes_html"><div class="ttname"><a href="classgg_1_1Attributes.html">gg::Attributes</a></div><div class="ttdef"><b>Definition:</b> Attributes.hpp:14</div></div>
<div class="ttc" id="aclassgg_1_1IEventSubscriber_html"><div class="ttname"><a href="classgg_1_1IEventSubscriber.html">gg::IEventSubscriber</a></div><div class="ttdef"><b>Definition:</b> Event.hpp:59</div></div>
<div class="ttc" id="aclassgg_1_1IEvent_html"><div class="ttname"><a href="classgg_1_1IEvent.html">gg::IEvent</a></div><div class="ttdef"><b>Definition:</b> Event.hpp:41</div></div>
<div class="ttc" id="aclassgg_1_1Tile_html"><div class="ttname"><a href="classgg_1_1Tile.html">gg::Tile</a></div><div class="ttdef"><b>Definition:</b> Tile.hpp:21</div></div>
<div class="ttc" id="aclassgg_1_1Tile_html_a0191b303c80a99a08d039b5bf750634c"><div class="ttname"><a href="classgg_1_1Tile.html#a0191b303c80a99a08d039b5bf750634c">gg::Tile::SetCoordinates</a></div><div class="ttdeci">void SetCoordinates(sf::Vector2f)</div></div>
<div class="ttc" id="aclassgg_1_1Tile_html_a10ad4cf3efcbf28f9619728645dbf177"><div class="ttname"><a href="classgg_1_1Tile.html#a10ad4cf3efcbf28f9619728645dbf177">gg::Tile::OnEvent</a></div><div class="ttdeci">void OnEvent(IEvent *e) override</div></div>
<div class="ttc" id="aclassgg_1_1Tile_html_a16878527ccba59914b345b7cf314df94"><div class="ttname"><a href="classgg_1_1Tile.html#a16878527ccba59914b345b7cf314df94">gg::Tile::OnMouseMoved</a></div><div class="ttdeci">virtual void OnMouseMoved(IEvent *e)</div></div>
<div class="ttc" id="aclassgg_1_1Tile_html_a1d29c8525bf4ff2360d8ed2da06417a2"><div class="ttname"><a href="classgg_1_1Tile.html#a1d29c8525bf4ff2360d8ed2da06417a2">gg::Tile::OnKeyboardReleased</a></div><div class="ttdeci">virtual void OnKeyboardReleased(IEvent *e)</div></div>
<div class="ttc" id="aclassgg_1_1Tile_html_a1f5447e844dced086af932cd654624b8"><div class="ttname"><a href="classgg_1_1Tile.html#a1f5447e844dced086af932cd654624b8">gg::Tile::mRotation</a></div><div class="ttdeci">unsigned mRotation</div><div class="ttdef"><b>Definition:</b> Tile.hpp:69</div></div>
<div class="ttc" id="aclassgg_1_1Tile_html_a301a080e5cdb580c2224a9548de9d753"><div class="ttname"><a href="classgg_1_1Tile.html#a301a080e5cdb580c2224a9548de9d753">gg::Tile::OnMousePressed</a></div><div class="ttdeci">virtual void OnMousePressed(IEvent *e)</div></div>
<div class="ttc" id="aclassgg_1_1Tile_html_a389b4f46707f195fa2ed2e22ec221cb6"><div class="ttname"><a href="classgg_1_1Tile.html#a389b4f46707f195fa2ed2e22ec221cb6">gg::Tile::GetVertices</a></div><div class="ttdeci">auto GetVertices() -&gt; TileVertices</div></div>
<div class="ttc" id="aclassgg_1_1Tile_html_a3ac25ea653262607007c15e5d68f9685"><div class="ttname"><a href="classgg_1_1Tile.html#a3ac25ea653262607007c15e5d68f9685">gg::Tile::GetOrientation</a></div><div class="ttdeci">auto GetOrientation() -&gt; unsigned</div></div>
<div class="ttc" id="aclassgg_1_1Tile_html_a3e180f4be66ea12ad1e2a95a66fad2e7"><div class="ttname"><a href="classgg_1_1Tile.html#a3e180f4be66ea12ad1e2a95a66fad2e7">gg::Tile::~Tile</a></div><div class="ttdeci">~Tile() override=0</div></div>
<div class="ttc" id="aclassgg_1_1Tile_html_a53d8865c694dfb8240eddce9fe1d6254"><div class="ttname"><a href="classgg_1_1Tile.html#a53d8865c694dfb8240eddce9fe1d6254">gg::Tile::GetTexture</a></div><div class="ttdeci">auto GetTexture() -&gt; sf::Texture *</div></div>
<div class="ttc" id="aclassgg_1_1Tile_html_a5df93094d59293b454a041b1fc780b51"><div class="ttname"><a href="classgg_1_1Tile.html#a5df93094d59293b454a041b1fc780b51">gg::Tile::GetTileType</a></div><div class="ttdeci">virtual auto GetTileType() -&gt; TileType=0</div></div>
<div class="ttc" id="aclassgg_1_1Tile_html_a6ccfd1b779c329f0db0434c7c84fb326"><div class="ttname"><a href="classgg_1_1Tile.html#a6ccfd1b779c329f0db0434c7c84fb326">gg::Tile::GetAttributes</a></div><div class="ttdeci">virtual auto GetAttributes() -&gt; Attributes=0</div></div>
<div class="ttc" id="aclassgg_1_1Tile_html_a716d8b8c491751d505c16efdfdb09ffd"><div class="ttname"><a href="classgg_1_1Tile.html#a716d8b8c491751d505c16efdfdb09ffd">gg::Tile::mCoordinates</a></div><div class="ttdeci">sf::Vector2f mCoordinates</div><div class="ttdef"><b>Definition:</b> Tile.hpp:66</div></div>
<div class="ttc" id="aclassgg_1_1Tile_html_a7266360d4b7b0603596252ffb1edce51"><div class="ttname"><a href="classgg_1_1Tile.html#a7266360d4b7b0603596252ffb1edce51">gg::Tile::Tile</a></div><div class="ttdeci">Tile(sf::Vector2f coordinates, sf::Texture &amp;texture, std::string texture_name, unsigned rotation)</div></div>
<div class="ttc" id="aclassgg_1_1Tile_html_a76d15a17d011f27adcd9defccf00f520"><div class="ttname"><a href="classgg_1_1Tile.html#a76d15a17d011f27adcd9defccf00f520">gg::Tile::Update</a></div><div class="ttdeci">virtual void Update()</div></div>
<div class="ttc" id="aclassgg_1_1Tile_html_a79fb964ccb4a15eafbca90b4de886c63"><div class="ttname"><a href="classgg_1_1Tile.html#a79fb964ccb4a15eafbca90b4de886c63">gg::Tile::Align</a></div><div class="ttdeci">virtual void Align()=0</div></div>
<div class="ttc" id="aclassgg_1_1Tile_html_aa41280d666d951b77e2b350abe440b57"><div class="ttname"><a href="classgg_1_1Tile.html#aa41280d666d951b77e2b350abe440b57">gg::Tile::mTexture</a></div><div class="ttdeci">sf::Texture * mTexture</div><div class="ttdef"><b>Definition:</b> Tile.hpp:65</div></div>
<div class="ttc" id="aclassgg_1_1Tile_html_aa73c8e60689b326a699777bf379ed67f"><div class="ttname"><a href="classgg_1_1Tile.html#aa73c8e60689b326a699777bf379ed67f">gg::Tile::SetTexture</a></div><div class="ttdeci">void SetTexture(std::string &amp;)</div></div>
<div class="ttc" id="aclassgg_1_1Tile_html_ab2075c2d7f3e48756092e2ffc4285119"><div class="ttname"><a href="classgg_1_1Tile.html#ab2075c2d7f3e48756092e2ffc4285119">gg::Tile::mTextureName</a></div><div class="ttdeci">std::string mTextureName</div><div class="ttdef"><b>Definition:</b> Tile.hpp:68</div></div>
<div class="ttc" id="aclassgg_1_1Tile_html_ac25ae0051a743d6d2268055b9b2a80f7"><div class="ttname"><a href="classgg_1_1Tile.html#ac25ae0051a743d6d2268055b9b2a80f7">gg::Tile::mSprite</a></div><div class="ttdeci">sf::Sprite mSprite</div><div class="ttdef"><b>Definition:</b> Tile.hpp:67</div></div>
<div class="ttc" id="aclassgg_1_1Tile_html_ad5401c7e1b74b3c556b1960d150c15f1"><div class="ttname"><a href="classgg_1_1Tile.html#ad5401c7e1b74b3c556b1960d150c15f1">gg::Tile::draw</a></div><div class="ttdeci">void draw(sf::RenderTarget &amp;target, sf::RenderStates states) const override</div></div>
<div class="ttc" id="aclassgg_1_1Tile_html_ad6b1fa9f1db1fb5aacb6bfb5f2984ad9"><div class="ttname"><a href="classgg_1_1Tile.html#ad6b1fa9f1db1fb5aacb6bfb5f2984ad9">gg::Tile::GetTextureName</a></div><div class="ttdeci">auto GetTextureName() const -&gt; const std::string &amp;</div><div class="ttdef"><b>Definition:</b> Tile.hpp:41</div></div>
<div class="ttc" id="aclassgg_1_1Tile_html_af6c613329acd85d3a7ebf194ae5fa763"><div class="ttname"><a href="classgg_1_1Tile.html#af6c613329acd85d3a7ebf194ae5fa763">gg::Tile::GetCoordinates</a></div><div class="ttdeci">auto GetCoordinates() -&gt; sf::Vector2f</div></div>
<div class="ttc" id="anamespacegg_html"><div class="ttname"><a href="namespacegg.html">gg</a></div><div class="ttdef"><b>Definition:</b> Application.hpp:22</div></div>
<div class="ttc" id="anamespacegg_html_a08ccf34451b5441314600ac46113a9f6"><div class="ttname"><a href="namespacegg.html#a08ccf34451b5441314600ac46113a9f6">gg::TileType</a></div><div class="ttdeci">TileType</div><div class="ttdef"><b>Definition:</b> Tile.hpp:11</div></div>
<div class="ttc" id="anamespacegg_html_a08ccf34451b5441314600ac46113a9f6a4ccfea7a25fae3c1d31555f0856d2b42"><div class="ttname"><a href="namespacegg.html#a08ccf34451b5441314600ac46113a9f6a4ccfea7a25fae3c1d31555f0856d2b42">gg::TileType::Terrain</a></div><div class="ttdeci">@ Terrain</div></div>
<div class="ttc" id="anamespacegg_html_a08ccf34451b5441314600ac46113a9f6ac39b56d4489fb2507289e7ae19567b80"><div class="ttname"><a href="namespacegg.html#a08ccf34451b5441314600ac46113a9f6ac39b56d4489fb2507289e7ae19567b80">gg::TileType::Building</a></div><div class="ttdeci">@ Building</div></div>
<div class="ttc" id="anamespacegg_html_a08ccf34451b5441314600ac46113a9f6ad11aed2ff81f20a2e2b7e0cf06ee1a37"><div class="ttname"><a href="namespacegg.html#a08ccf34451b5441314600ac46113a9f6ad11aed2ff81f20a2e2b7e0cf06ee1a37">gg::TileType::Road</a></div><div class="ttdeci">@ Road</div></div>
<div class="ttc" id="anamespacestd_html"><div class="ttname"><a href="namespacestd.html">std</a></div><div class="ttdef"><b>Definition:</b> Event.hpp:84</div></div>
<div class="ttc" id="astructgg_1_1TileVertices_html"><div class="ttname"><a href="structgg_1_1TileVertices.html">gg::TileVertices</a></div><div class="ttdef"><b>Definition:</b> Tile.hpp:13</div></div>
<div class="ttc" id="astructgg_1_1TileVertices_html_a12a105e4bbd87645f296444aea39d985"><div class="ttname"><a href="structgg_1_1TileVertices.html#a12a105e4bbd87645f296444aea39d985">gg::TileVertices::right</a></div><div class="ttdeci">sf::Vector2f right</div><div class="ttdef"><b>Definition:</b> Tile.hpp:16</div></div>
<div class="ttc" id="astructgg_1_1TileVertices_html_a60fb411502ff67e65d6f270dfa4d1fd3"><div class="ttname"><a href="structgg_1_1TileVertices.html#a60fb411502ff67e65d6f270dfa4d1fd3">gg::TileVertices::bottom</a></div><div class="ttdeci">sf::Vector2f bottom</div><div class="ttdef"><b>Definition:</b> Tile.hpp:17</div></div>
<div class="ttc" id="astructgg_1_1TileVertices_html_aa9d3f0cc48da0f5b741f1eb8fa43add0"><div class="ttname"><a href="structgg_1_1TileVertices.html#aa9d3f0cc48da0f5b741f1eb8fa43add0">gg::TileVertices::left</a></div><div class="ttdeci">sf::Vector2f left</div><div class="ttdef"><b>Definition:</b> Tile.hpp:14</div></div>
<div class="ttc" id="astructgg_1_1TileVertices_html_ab87101f5f35289a4fa7e8bacf14cb097"><div class="ttname"><a href="structgg_1_1TileVertices.html#ab87101f5f35289a4fa7e8bacf14cb097">gg::TileVertices::top</a></div><div class="ttdeci">sf::Vector2f top</div><div class="ttdef"><b>Definition:</b> Tile.hpp:15</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.3
</small></address>
</body>
</html>
